function app-stop {
	#Stops Orchistrations
	foreach ($orchName in $orchistrations)
	{
		$orch = Get-WmiObject MSBTS_Orchestration -n root\MicrosoftBizTalkServer -filter "Name='$orchName'"
		if ($orch.OrchestrationStatus -ne "2") {
			if ($orch.OrchestrationStatus -eq "3" -or $orch.OrchestrationStatus -eq "4") {
				if ($orch.OrchestrationStatus -eq "4"){
				$orch.Stop()
				}

			$orch.Unenlist()
			}
		}
		else {
		Write-Host "Orchestration already stopped and unenlisted"
		}
	}
	#Stops Send Ports
	foreach ($portName in $sendports) {
		$sp = Get-WmiObject MSBTS_SendPort -n root\MicrosoftBizTalkServer -filter "Name='$portName'"
		if ($sp.Status -ne "1") {
			if ($sp.Status -eq "3" -or $sp.Status -eq "2") {
				if ($sp.Status -eq "2") {
				$sp.Stop()
				}

			$sp.Unenlist()
			}
		}
		else {
		Write-Host "Send ports are already disabled and stopped"
		}

	}

	#Disables recieve Ports
	foreach ($locationName in $recieveLocations){
		$rec = get-wmiobject MSBTS_ReceiveLocation -n root\MicrosoftBizTalkServer -filter "ReceivePortName='$locationName'"
		$rec.Disable()
	}
}
function app-start{
	#Starts Send Ports
	foreach ($portName in $sendports){
		$sp = Get-WmiObject MSBTS_SendPort -n root\MicrosoftBizTalkServer -filter "Name='$portName'"
		if ($sp.Status -ne "3")	{
			if ($sp.Status -eq "1" -or $sp.Status -eq "2") {
				if ($sp.Status -eq "1") {
				    $sp.Enlist
				}
			    $sp.Start()
			}
		    else {
		        write-host "Send ports already enlisted and started"
		    }
		}
	}
	#Enables Recieve locations
	foreach ($locationName in $recieveLocations) {
		$rec = get-wmiobject MSBTS_ReceiveLocation -n root\MicrosoftBizTalkServer -filter "ReceivePortName='$locationName'"
	    $rec.Enable()
	}

	#Starts Orchistrations
	foreach ($orchName in $orchistrations){
		$orch = Get-WmiObject MSBTS_Orchestration -n root\MicrosoftBizTalkServer -filter "Name='$orchName'"
		if ($orch.OrchestrationStatus -ne "4"){
			if ($orch.OrchestrationStatus -eq "2" -or $orch.OrchestrationStatus -eq "3") {
				if ($orch.OrchestrationStatus -eq "2") {
				$orch.Enlist()
				}
			$orch.Start()
			}
		}
		Else
		{
		Write-Host "Orchestration is already enlisted and started"
		}
	}
}
function host-restart {
	#restarts host instance
	$instancehost = Get-WmiObject MSBTS_HostInstance -n 'root\MicrosoftBizTalkServer' -filter HostType=1
	$instancehost.Stop()
	$instancehost.Start()
}

function get-values {
	Write-Host "starting get values"
	#clear array variables
	$orchistrations.Clear()
	$sendports.Clear()
	$recieveLocations.Clear()

	$btsCatExp = New-Object Microsoft.BizTalk.ExplorerOM.BtsCatalogExplorer
	$btsCatExp.ConnectionString = "Integrated Security=SSPI;database=BizTalkMgmtDb;server=."

	$SendPortList = $btsCatExp.Applications[$appName].SendPorts
	$OrchestrationsList = $btsCatExp.Applications[$appName].Orchestrations
	$ReceivePortList = $btsCatExp.Applications[$appName].ReceivePorts

	foreach ($i in $SendPortList) {
		$sendports.Add($i.Name)
	}
	foreach ($i in $OrchestrationsList) {
		$orchistrations.Add($i.FullName)
	}
	foreach ($i in $ReceivePortList){
		$recieveLocations.Add($i.Name)
	}
	Write-Host $sendports
	Write-Host $orchistrations
	Write-Host $recieveLocations
	Write-Host "get values complete"
}

#Enter program Here
$orchistrations = New-Object System.Collections.ArrayList
$sendports = New-Object System.Collections.ArrayList
$recieveLocations = New-Object System.Collections.ArrayList
[Reflection.Assembly]::LoadWithPartialName("Microsoft.BizTalk.ExplorerOM")
$btsCatExp = New-Object Microsoft.BizTalk.ExplorerOM.BtsCatalogExplorer
$btsCatExp.ConnectionString = "Integrated Security=SSPI;database=BizTalkMgmtDb;server=."
$appName = $args[0]
$command = $args[1]

if ($btsCatExp.Applications[$appName] -ne $null -and $command -eq "start"){
	$action = "start"
}
elseif ($btsCatExp.Applications[$appName] -ne $null -and $command -eq "stop"){
	$action = "stop"
}

Switch($action) {

	"start" {

	    get-values

	    app-start

	}


	"stop" {

	    get-values

	    app-stop

	}

	default {
	    Write-Host "Invalid application name: $appName"
            exit 1
	}
}


